diff -ur snort-2.0.2/src/fpcreate.c snort-2.0.2-ipv6/src/fpcreate.c
--- snort-2.0.2/src/fpcreate.c	Tue Jun 10 06:04:43 2003
+++ snort-2.0.2-ipv6/src/fpcreate.c	Sat Nov 29 15:49:59 2003
@@ -1,5 +1,5 @@
 /*
-**  $Id: fpcreate.c,v 1.5 2003/06/09 21:04:43 chrisgreen Exp $
+**  $Id: fpcreate.c,v 1.2 2003/11/29 06:49:59 abekatsu Exp $
 ** 
 **  fpcreate.c
 **
@@ -37,7 +37,9 @@
 #include "sp_pattern_match.h"
 #include "sp_icmp_code_check.h"
 #include "sp_icmp_type_check.h"
+#include "sp_icmp6_type_check.h"
 #include "sp_ip_proto.h"
+#include "sp_ip6_proto.h"
 #include "plugin_enum.h"
 #include "util.h"
 
@@ -70,6 +72,8 @@
 static PORT_RULE_MAP *prmUdpRTNX = NULL;
 static PORT_RULE_MAP *prmIpRTNX  = NULL;
 static PORT_RULE_MAP *prmIcmpRTNX= NULL;
+static PORT_RULE_MAP *prmIp6RTNX  = NULL;
+static PORT_RULE_MAP *prmIcmp6RTNX= NULL;
 
 static FPDETECT fpDetect;
 
@@ -86,12 +90,24 @@
     return prmFindRuleGroup( prmIpRTNX, ip_proto, -1, &src, ip_group, gen);
 }
 
+int prmFindRuleGroupIp6(int ip6_proto, PORT_GROUP **ip6_group, PORT_GROUP ** gen)
+{
+    PORT_GROUP *src;
+    return prmFindRuleGroup( prmIp6RTNX, ip6_proto, -1, &src, ip6_group, gen);
+}
+
 int prmFindRuleGroupIcmp(int type, PORT_GROUP **type_group, PORT_GROUP ** gen)
 {
     PORT_GROUP *src;
     return prmFindRuleGroup( prmIcmpRTNX, type, -1, &src, type_group, gen);
 }
 
+int prmFindRuleGroupIcmp6(int type, PORT_GROUP **type_group, PORT_GROUP ** gen)
+{
+    PORT_GROUP *src;
+    return prmFindRuleGroup( prmIcmp6RTNX, type, -1, &src, type_group, gen);
+}
+
 int prmFindRuleGroupTcp(int dport, int sport, PORT_GROUP ** src, 
         PORT_GROUP **dst , PORT_GROUP ** gen)
 {
@@ -679,6 +695,14 @@
     if(prmIcmpRTNX == NULL)
         return 1;
 
+    prmIp6RTNX = prmNewMap();
+    if(prmIp6RTNX == NULL)
+        return 1;
+
+    prmIcmp6RTNX = prmNewMap();
+    if(prmIcmp6RTNX == NULL)
+        return 1;
+
     for (rule=RuleLists; rule; rule=rule->next)
     {
         if(!rule->RuleList)
@@ -942,6 +966,58 @@
             }
         }
 
+	/*
+	 *  Process ICMP6 signatures 
+	 */
+
+	if(rule->RuleList->Icmp6List)
+	{
+            for(rtn = rule->RuleList->Icmp6List; rtn != NULL; rtn = rtn->right)
+	    {
+               /* Walk OTN list -Add as Content, or NoContent */
+                for( otn = rtn->down; otn; otn=otn->next )
+		{
+                    int type;
+                    Icmp6TypeCheckData * Icmp6Type;
+
+                    otnx = malloc( sizeof(OTNX) );
+                    MEMASSERT(otnx,"otnx-ICMP6");
+
+                    otnx->otn = otn;
+                    otnx->rtn = rtn;
+	            
+		    Icmp6Type = (Icmp6TypeCheckData *)otn->ds_list[PLUGIN_ICMP6_TYPE];
+                    if( Icmp6Type )
+                    {
+                        type = Icmp6Type->icmp6_type;
+                    }
+                    else
+                    {
+                        type = -1;
+                    }
+
+                    if( OtnHasContent( otn ) )
+                    {
+                        if(fpDetect.debug)
+                        {
+                            printf("ICMP6 Type=%d Content-Rule  %s\n",
+                                    type,otn->sigInfo.message);
+                        }
+                        prmAddRule(prmIcmp6RTNX, type, -1, otnx);
+                    }
+                    else
+                    {
+                        if(fpDetect.debug)
+                        {
+                            printf("ICMP6 Type=%d NoContent-Rule  %s\n",
+                                    type,otn->sigInfo.message);
+                        }
+                        prmAddRuleNC(prmIcmp6RTNX, type, -1, otnx);
+                    }
+		}
+	    }
+	}
+
         /*
         **  Process IP signatures
         **
@@ -1037,17 +1113,113 @@
                 }
             }
         }
+
+        /*
+	 *  Process IPv6 signatures
+	 */
+        if(rule->RuleList->Ip6List)
+	{
+            for(rtn = rule->RuleList->Ip6List; rtn != NULL; rtn = rtn->right)
+	    {
+                /* Walk OTN list -Add as Content, or NoContent */
+                for( otn=rtn->down; otn; otn=otn->next )
+		{
+                    Ip6ProtoData * Ip6Proto;
+                    int protocol;
+
+                    otnx = malloc( sizeof(OTNX) );
+                    MEMASSERT(otnx,"otnx-IP6");
+
+                    otnx->otn = otn;
+                    otnx->rtn = rtn;
+
+                    Ip6Proto =  
+                        (Ip6ProtoData *)otn->ds_list[PLUGIN_IP6_PROTO_CHECK] ;
+
+                    if( Ip6Proto )
+                    {
+                        protocol = Ip6Proto->protocol;
+                        if( Ip6Proto->comparison_flag == GREATER_THAN )
+                            protocol=-1; 
+                        
+                        if( Ip6Proto->comparison_flag == LESS_THAN )
+                            protocol=-1; 
+
+                        if( Ip6Proto->not_flag )
+                            protocol=-1;
+
+                    }
+                    else
+                    {
+                        protocol = -1;
+                    }
+
+                    if( OtnHasContent( otn ) )
+		    {
+                        if(fpDetect.debug)
+                        {
+                            printf("IP6 Proto=%d Content-Rule %s\n",
+                                    protocol,otn->sigInfo.message);
+                        }
+                        prmAddRule(prmIp6RTNX, protocol, -1, otnx);
+
+                        if(protocol == IPPROTO_TCP || protocol == -1)
+                        {
+                            prmAddRule(prmTcpRTNX, -1, -1, otnx);
+                        }
+                        
+                        if(protocol == IPPROTO_UDP || protocol == -1)
+                        {
+                            prmAddRule(prmUdpRTNX, -1, -1, otnx);
+                        }
+
+                        if(protocol == IPPROTO_ICMPV6 || protocol == -1)
+                        {
+                            prmAddRule(prmIcmp6RTNX, -1, -1, otnx);
+                        }
+		    }
+		    else
+		    {
+                        if(fpDetect.debug)
+                        {
+                            printf("IP6 Proto=%d NoContent-Rule %s\n",
+                                    protocol,otn->sigInfo.message);
+                        }
+                        prmAddRuleNC(prmIp6RTNX, protocol, -1, otnx);
+
+                        if(protocol == IPPROTO_TCP || protocol == -1)
+                        {
+                            prmAddRuleNC(prmTcpRTNX, -1, -1, otnx);
+                        }
+                        
+                        if(protocol == IPPROTO_UDP || protocol == -1)
+                        {
+                            prmAddRuleNC(prmUdpRTNX, -1, -1, otnx);
+                        }
+
+                        if(protocol == IPPROTO_ICMPV6 || protocol == -1)
+                        {
+                            prmAddRuleNC(prmIcmp6RTNX, -1, -1, otnx);
+                        }
+		    }
+		}
+	    }
+	}
     }
 
     prmCompileGroups(prmTcpRTNX);
     prmCompileGroups(prmUdpRTNX);
     prmCompileGroups(prmIcmpRTNX);
+    prmCompileGroups(prmIcmp6RTNX);
     prmCompileGroups(prmIpRTNX);
+    prmCompileGroups(prmIp6RTNX);
 
     BuildMultiPatternGroups(prmTcpRTNX);
     BuildMultiPatternGroups(prmUdpRTNX);
     BuildMultiPatternGroups(prmIcmpRTNX);
+    BuildMultiPatternGroups(prmIcmp6RTNX);
     BuildMultiPatternGroups(prmIpRTNX);
+    BuildMultiPatternGroups(prmIp6RTNX);
 
     if(fpDetect.debug)
     {
@@ -1059,9 +1231,15 @@
     
         printf("\n** ICMP Rule Group Stats -- ");
         prmShowStats(prmIcmpRTNX);
+
+        printf("\n** ICMP6 Rule Group Stats -- ");
+        prmShowStats(prmIcmp6RTNX);
     
         printf("\n** IP Rule Group Stats -- ");
         prmShowStats(prmIpRTNX);
+
+        printf("\n** IP6 Rule Group Stats -- ");
+        prmShowStats(prmIp6RTNX);
     }
 
     return 0;
@@ -1083,7 +1261,9 @@
     printf("\n** TCP Event Stats -- ");  prmShowEventStats(prmTcpRTNX);
     printf("\n** UDP Event Stats -- ");  prmShowEventStats(prmUdpRTNX);
     printf("\n** ICMP Event Stats -- "); prmShowEventStats(prmIcmpRTNX);
+    printf("\n** ICMP6 Event Stats -- "); prmShowEventStats(prmIcmp6RTNX);
     printf("\n** IP Event Stats -- ");    prmShowEventStats(prmIpRTNX);
+    printf("\n** IP6 Event Stats -- ");    prmShowEventStats(prmIp6RTNX);
     return 0;
 }
    
diff -ur snort-2.0.2/src/fpcreate.h snort-2.0.2-ipv6/src/fpcreate.h
--- snort-2.0.2/src/fpcreate.h	Fri Apr 11 06:21:51 2003
+++ snort-2.0.2-ipv6/src/fpcreate.h	Sat Nov 29 15:50:13 2003
@@ -1,5 +1,5 @@
 /*
-**  $Id: fpcreate.h,v 1.2 2003/04/10 21:21:51 chris_reid Exp $
+**  $Id: fpcreate.h,v 1.2 2003/11/29 06:50:13 abekatsu Exp $
 **
 **  fpclass.h
 **
@@ -95,6 +95,8 @@
 int prmFindRuleGroupUdp(int dport, int sport, PORT_GROUP ** src, PORT_GROUP **dst , PORT_GROUP ** gen);
 int prmFindRuleGroupIp(int ip_proto, PORT_GROUP **ip_group, PORT_GROUP ** gen);
 int prmFindRuleGroupIcmp(int type, PORT_GROUP **type_group, PORT_GROUP ** gen);
+int prmFindRuleGroupIp6(int ip6_proto, PORT_GROUP **ip6_group, PORT_GROUP ** gen);
+int prmFindRuleGroupIcmp6(int type, PORT_GROUP **type_group, PORT_GROUP ** gen);
 
 int fpSetDetectSearchMethod( char * method );
 int fpSetDebugMode();
diff -ur snort-2.0.2/src/fpdetect.c snort-2.0.2-ipv6/src/fpdetect.c
--- snort-2.0.2/src/fpdetect.c	Thu Sep 11 05:19:50 2003
+++ snort-2.0.2-ipv6/src/fpdetect.c	Sat Nov 29 15:54:29 2003
@@ -1,5 +1,5 @@
 /*
-**  $Id: fpdetect.c,v 1.3 2003/07/17 05:51:37 tburgess Exp $
+**  $Id: fpdetect.c,v 1.3 2003/11/29 06:54:29 abekatsu Exp $
 **
 **  fpdetect.c
 **
@@ -129,7 +129,9 @@
 static INLINE int fpEvalRTNSW(RuleTreeNode *rtn, OptTreeNode *otn, Packet *p, 
         int check_ports);
 static INLINE int fpEvalHeaderIp(Packet *p, int ip_proto);
+static INLINE int fpEvalHeaderIp6(Packet *p, int ip_proto);
 static INLINE int fpEvalHeaderIcmp(Packet *p);
+static INLINE int fpEvalHeaderIcmp6(Packet *p);
 static INLINE int fpEvalHeaderTcp(Packet *p);
 static INLINE int fpEvalHeaderUdp(Packet *p);
 static INLINE int fpEvalHeaderSW(PORT_GROUP *port_group, Packet *p, 
@@ -1257,6 +1259,59 @@
 }
 
 /*
+**  fpEvalHeaderICMP6::
+*/
+static INLINE int fpEvalHeaderIcmp6(Packet *p)
+{
+    PORT_GROUP *gen, *type;
+    int retval;
+
+    retval = prmFindRuleGroupIcmp6(p->icmp6h->icmp6_type, &type, &gen);
+
+    switch(retval)
+    {
+        case 0:
+            return 0;
+        case 1:
+            InitMatchInfo( &omd );
+            
+            /* icmp type */
+#ifdef FPSW
+            if(fpEvalHeaderSW(type, p, 0))
+#else
+            if(fpEvalHeader(type, p, 0))
+#endif
+            {
+                return 1;
+            }
+
+            break;
+        case 2:
+            return 0;
+        case 3:
+            return 0;
+        case 4:
+            InitMatchInfo( &omd );
+            
+            /*  generic */
+#ifdef FPSW
+            if(fpEvalHeaderSW(gen, p, 0))
+#else
+            if(fpEvalHeader(gen, p, 0))
+#endif
+            {
+                return 1;
+            }
+
+            break;
+        default:
+            return 0;
+    }
+
+    return fpFinalSelectEvent(&omd, p);
+}
+
+/*
 **  fpEvalHeaderIP::
 */
 static INLINE int fpEvalHeaderIp(Packet *p, int ip_proto)
@@ -1311,6 +1366,60 @@
 }
 
 /*
+**  fpEvalHeaderIP6::
+*/
+static INLINE int fpEvalHeaderIp6(Packet *p, int ip_proto)
+{
+    PORT_GROUP *gen, *ip6_group;
+    int retval;
+
+    retval = prmFindRuleGroupIp6(ip_proto, &ip6_group, &gen);
+ 
+    switch(retval)
+    {
+        case 0:
+            return 0;
+        case 1:
+            InitMatchInfo( &omd );
+            
+            /* ip_group */
+#ifdef FPSW
+            if(fpEvalHeaderSW(ip6_group, p, 0))
+#else
+            if(fpEvalHeader(ip6_group, p, 0))
+#endif
+            {
+                return 1;
+            }
+
+            break;
+        case 2:
+            return 0;
+        case 3:
+            return 0;
+        case 4:
+            InitMatchInfo( &omd );
+            
+            /* generic */
+#ifdef FPSW
+            if(fpEvalHeaderSW(gen, p, 0))
+#else
+            if(fpEvalHeader(gen, p, 0))
+#endif
+            {
+                return 1;
+            }
+
+            break;
+
+        default:
+            return 0;
+    }
+
+    return fpFinalSelectEvent(&omd, p);
+}
+
+/*
 **
 **  NAME
 **    fpEvalPacket::
@@ -1337,7 +1446,17 @@
 */
 int fpEvalPacket(Packet *p)
 {
-    int ip_proto = p->iph->ip_proto;
+    int ip_proto;
+
+    if (p->iph == NULL && p->ip6h == NULL)
+	return 0;
+
+    if (p->iph != NULL) 
+	ip_proto = p->iph->ip_proto;
+    else if (p->ip6h != NULL) 
+	ip_proto = p->ip6h->s_ip6_nxt;
+    else
+	return 0;
 
     switch(ip_proto)
     {
@@ -1383,6 +1502,20 @@
 
             return 0;
 
+        case IPPROTO_ICMPV6:
+            DEBUG_WRAP(DebugMessage(DEBUG_DETECT, 
+                        "Detecting on Icmp6List\n"););
+
+            if(p->icmp6h == NULL)
+            {
+                ip_proto = -1;
+                break; 
+            }
+
+            fpEvalHeaderIcmp6(p);
+
+            return 0;
+
         default:
             break;
     }
@@ -1390,8 +1523,10 @@
     /*
     **  No Match on TCP/UDP, Do IP
     */
-    fpEvalHeaderIp(p, ip_proto);
-
+    if (p->iph != NULL) 
+	fpEvalHeaderIp(p, ip_proto);
+    else if (p->ip6h != NULL) 
+	fpEvalHeaderIp6(p, ip_proto); 
 
     return 0;
 }
diff -ur snort-2.0.2/src/fpdetect.h snort-2.0.2-ipv6/src/fpdetect.h
--- snort-2.0.2/src/fpdetect.h	Thu Sep 11 05:19:50 2003
+++ snort-2.0.2-ipv6/src/fpdetect.h	Tue Sep 30 13:25:25 2003
@@ -1,5 +1,5 @@
 /*
-** $Id: fpdetect.h,v 1.4 2003/07/17 05:51:37 tburgess Exp $
+** $Id: fpdetect.h,v 1.1.1.1 2003/09/30 04:25:25 abekatsu Exp $
 **
 ** fpfuncs.h
 **
diff -ur snort-2.0.2/src/generators.h snort-2.0.2-ipv6/src/generators.h
--- snort-2.0.2/src/generators.h	Mon Mar 31 22:12:58 2003
+++ snort-2.0.2-ipv6/src/generators.h	Fri Nov  7 16:04:39 2003
@@ -1,4 +1,4 @@
-/* $Id: generators.h,v 1.33 2003/03/31 13:12:58 chrisgreen Exp $ */
+/* $Id: generators.h,v 1.2 2003/11/07 07:04:39 abekatsu Exp $ */
 /*
 ** Copyright (C) 1998-2002 Martin Roesch <roesch@sourcefire.com>
 **
@@ -164,6 +164,11 @@
 #define     DECODE_BAD_TR_MR_LEN                  142
 #define     DECODE_BAD_TRHMR                      143
 
+#define     DECODE_NOT_IPV6_DGRAM                 150
+#define     DECODE_TRUNCATED_IPV6_FRAG_HDR        151
+#define     DECODE_TRUNCATED_ICMPV6_HDR           152
+#define     DECODE_IPV6_DGRAM_UNKNOWN             153
+
 #define GENERATOR_SPP_SCAN2         117
 #define     SCAN_TYPE                             1
 
@@ -242,6 +247,9 @@
 #define DECODE_IPV4OPT_BADLEN_STR      "(snort_decoder): Ipv4 Options found with bad lengths"
 #define DECODE_IPV4OPT_TRUNCATED_STR   "(snort_decoder): Truncated Ipv4 Options"
 
+#define DECODE_NOT_IPV6_DGRAM_STR "(snort_decoder) WARNING: Not IPv6 datagram!"
+#define DECODE_TRUNCATED_IPV6_FRAG_HDR_STR "(snort_decoder) WARNING: Truncated IPv6 Fragment header!"
+
 #define DECODE_TCP_DGRAM_LT_TCPHDR_STR "(snort_decoder) TCP packet len is smaller than 20 bytes!"
 #define DECODE_TCP_INVALID_OFFSET_STR "(snort_decoder) WARNING: TCP Data Offset is less than 5!"
 #define DECODE_TCP_LARGE_OFFSET_STR "(snort_decoder) WARNING: TCP Header length exceeds packet length!"
@@ -261,7 +269,11 @@
 #define DECODE_ICMP_DGRAM_LT_ICMPHDR_STR "(snort_decoder) WARNING: ICMP Header Truncated!"
 #define DECODE_ICMP_DGRAM_LT_TIMESTAMPHDR_STR "(snort_decoder) WARNING: ICMP Timestamp Header Truncated!"
 #define DECODE_ICMP_DGRAM_LT_ADDRHDR_STR "(snort_decoder) WARNING: ICMP Address Header Truncated!"
+
+#define DECODE_TRUNCATED_ICMPV6_HDR_STR "(snort_decoder) WARNING: Truncated ICMPv6 header"
+
 #define DECODE_IPV4_DGRAM_UNKNOWN_STR "(snort_decoder) Unknown Datagram decoding problem!"
+#define DECODE_IPV6_DGRAM_UNKNOWN_STR "(snort_decoder) Unknown Datagram decoding problem!"
 #define DECODE_ARP_TRUNCATED_STR "(snort_decoder) WARNING: Truncated ARP!"
 #define DECODE_EAPOL_TRUNCATED_STR "(snort_decoder) WARNING: Truncated EAP Header!"
 #define DECODE_EAPKEY_TRUNCATED_STR "(snort_decoder) WARNING: EAP Key Truncated!"
diff -ur snort-2.0.2/src/log.c snort-2.0.2-ipv6/src/log.c
--- snort-2.0.2/src/log.c	Thu Apr 10 06:12:24 2003
+++ snort-2.0.2-ipv6/src/log.c	Tue Nov 11 12:02:25 2003
@@ -1,4 +1,4 @@
-/* $Id: log.c,v 1.114 2003/04/09 21:12:24 chrisgreen Exp $ */
+/* $Id: log.c,v 1.5 2003/11/11 03:02:25 abekatsu Exp $ */
 /*
 ** Copyright (C) 1998-2002 Martin Roesch <roesch@sourcefire.com>
 **
@@ -427,6 +427,111 @@
             "=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+\n\n");
 }
 
+/*
+ * Function: PrintIPP6kt(FILE *, int, Packet *)
+ *
+ * Purpose: Dump the packet to the stream pointer
+ *
+ * Arguments: fp => pointer to print data to
+ *            type => packet protocol
+ *            p => pointer to decoded packet struct
+ *
+ * Returns: void function
+ */
+void PrintIP6Pkt(FILE * fp, int type, Packet * p)
+{
+    char timestamp[TIMEBUF_SIZE];
+
+    DEBUG_WRAP(DebugMessage(DEBUG_LOG, "PrintIP6Pkt type = %d\n", type););
+
+    bzero((char *) timestamp, TIMEBUF_SIZE);
+    ts_print((struct timeval *) & p->pkth->ts, timestamp);
+
+    /* dump the timestamp */
+    fwrite(timestamp, strlen(timestamp), 1, fp);
+
+    /* dump the ethernet header if we're doing that sort of thing */
+    if(pv.show2hdr_flag)
+    {
+        Print2ndHeader(fp, p);
+    }
+
+    /* etc */
+    PrintIP6Header(fp, p);
+
+    /* if this isn't a fragment, print the other header info */
+    if(!p->frag_flag)
+    {
+        switch(p->ip6h->s_ip6_nxt)
+        {
+            case IPPROTO_TCP:
+                if(p->tcph != NULL)
+                {
+                    PrintTCPHeader(fp, p);
+                }
+                else
+                {
+		  PrintNetData(fp, (u_char *)
+				 ((u_char *)p->ip6h + IP6_HEADER_LEN), 
+				 p->ip6h->s_ip6_plen);
+                }
+
+                break;
+
+            case IPPROTO_UDP:
+                if(p->udph != NULL)
+                {
+                    PrintUDPHeader(fp, p);
+                }
+                else
+                {
+                    PrintNetData(fp, (u_char *) 
+				 ((u_char *)p->ip6h + IP6_HEADER_LEN), 
+				 p->ip6h->s_ip6_plen);
+                }
+
+                break;
+
+            case IPPROTO_ICMPV6:
+                if(p->icmp6h != NULL)
+                {
+                    PrintICMP6Header(fp, p);
+                }
+                else
+                {
+/*
+		   printf("p->ip6h: %p\n", p->ip6h);
+		   printf("p->icmp6h: %p\n", p->icmp6h);
+		   printf("p->ip6h->s_ip6_plen: %d\n", p->ip6h->s_ip6_plen);
+ */
+                    PrintNetData(fp, (u_char *) 
+				 ((u_char *)p->ip6h + IP6_HEADER_LEN), 
+				 p->ip6h->s_ip6_plen);
+                }
+
+                break;
+
+            default:
+                break;
+        }
+    }
+    /* dump the application layer data */
+    if(pv.data_flag && !pv.verbose_bytedump_flag)
+    {
+        if(pv.char_data_flag)
+            PrintCharData(fp, (char*) p->data, p->dsize);
+        else
+            PrintNetData(fp, p->data, p->dsize);
+    }
+    else if(pv.verbose_bytedump_flag)
+    {
+        PrintNetData(fp, p->pkt, p->pkth->caplen);
+    }
+
+    fprintf(fp, "=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+"
+            "=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+\n\n");
+}
+
 
 
 /****************************************************************************
@@ -860,12 +965,15 @@
         fprintf(fp, "IP header truncated\n");
         return;
     }
+
     if(p->frag_flag)
     {
         /* just print the straight IP header */
-        fputs(inet_ntoa(p->iph->ip_src), fp);
-        fwrite(" -> ", 4, 1, fp);
-        fputs(inet_ntoa(p->iph->ip_dst), fp);
+
+	fputs(inet_ntoa(p->iph->ip_src), fp);
+	fwrite(" -> ", 4, 1, fp);
+	fputs(inet_ntoa(p->iph->ip_dst), fp);
+	
     }
     else
     {
@@ -939,6 +1047,78 @@
     }
 }
 
+/****************************************************************************
+ *
+ * Function: PrintIPHeader(FILE *)
+ *
+ * Purpose: Dump the IPv6 header info to the specified stream
+ *
+ * Arguments: fp => stream to print to
+ *
+ * Returns: void function
+ *
+ ***************************************************************************/
+void PrintIP6Header(FILE *fp, Packet *p)
+{
+    char src[INET6_ADDRSTRLEN], dst[INET6_ADDRSTRLEN];
+
+    if(p->ip6h == NULL)
+    {
+        fprintf(fp, "IP header truncated\n");
+        return;
+    }
+
+    (void) inet_ntop(PF_INET6, (void *)&(p->ip6h->ip6_src), src, sizeof(src));
+    (void) inet_ntop(PF_INET6, (void *)&(p->ip6h->ip6_dst), dst, sizeof(src));
+
+    if(p->frag_flag)
+    {
+        /* just print the straight IP header */
+	/* Not reach here currently */
+
+        /*
+	 * fputs(inet_ntoa(p->iph->ip_src), fp);
+	 * fwrite(" -> ", 4, 1, fp);
+	 * fputs(inet_ntoa(p->iph->ip_dst), fp);
+	 */
+    }
+    else
+    {
+        if(p->ip6h->s_ip6_nxt != IPPROTO_TCP && p->ip6h->s_ip6_nxt != IPPROTO_UDP)
+	{
+            /* just print the straight IP header */
+	    fprintf(fp, "%s -> %s", src, dst);
+	}
+	else
+	{
+	    if(!pv.obfuscation_flag)
+            {
+                /* print the header complete with port information */
+                fprintf(fp, "[%s]:%d -> [%s]:%d", src, p->sp, dst, p->dp);
+            }
+            else
+            {
+                /* print the header complete with port information */
+                fprintf(fp, "[xxxx:xxxx:xxxx:xxxx:xxxx:xxxx:xxxx:xxxx]:%d -> [xxxx:xxxx:xxxx:xxxx:xxxx:xxxx:xxxx:xxxx]:%d", p->sp, p->dp);
+            }	     
+	}
+    }
+
+    if(!pv.show2hdr_flag)
+    {
+        fputc('\n', fp);
+    }
+    else
+    {
+        fputc(' ', fp);
+    }
+
+    fprintf(fp, "%s FlowID:%08lx Ip6PayLoadLen:%d HopLimit:%d\n",
+            protocol_names[p->ip6h->s_ip6_nxt], 
+	    ntohl(p->ip6h->s_ip6_flow), ntohs(p->ip6h->s_ip6_plen),
+            p->ip6h->s_ip6_hlim);
+
+}
 
 
 /****************************************************************************
@@ -1426,6 +1606,114 @@
 
     putc('\n', fp);
 
+}
+
+/****************************************************************************
+ *
+ * Function: PrintICMP6Header(FILE *)
+ *
+ * Purpose: Print ICMPv6 header
+ *
+ * Arguments: fp => file stream
+ *
+ * Returns: void function
+ *
+ ***************************************************************************/
+void PrintICMP6Header(FILE * fp, Packet * p)
+{
+    if(p->icmp6h == NULL)
+    {
+        fprintf(fp, "ICMP6 header truncated\n");
+        return;
+    }
+
+    fprintf(fp, "Type:%d  Code:%d  ", p->icmp6h->icmp6_type, p->icmp6h->icmp6_code);
+
+    switch(p->icmp6h->icmp6_type)
+    {
+    case ICMP6_DST_UNREACH:
+	 fwrite("DESTINATION UNREACHABLE: ", 25, 1, fp);
+	 switch(p->icmp6h->icmp6_code)
+	 {
+	 case ICMP6_DST_UNREACH_NOROUTE:
+	      fwrite("DESTINATION NOROUTE", 19, 1, fp);
+	      break;
+	 case ICMP6_DST_UNREACH_ADMIN:
+	      fwrite("ADMINISTRATIVELY PROHIBITED", 27, 1, fp);
+	      break;
+	 case ICMP6_DST_UNREACH_BEYONDSCOPE:
+	      fwrite("BEYOND SCOPE OF SOURCE ADDRESS", 30, 1, fp);
+	      break;
+	 case ICMP6_DST_UNREACH_ADDR:
+	      fwrite("ADDRESS UNREACHABLE", 19, 1, fp);
+	      break;
+	 case ICMP6_DST_UNREACH_NOPORT:
+	      fwrite("PORT UNREACHABLE", 16, 1, fp);
+	      break;
+	 default:
+	      fwrite("UNKNOWN", 7, 1, fp);
+	      break;
+	 }
+	 {
+	      Packet op;
+	      Packet *orig_p;
+
+	      bzero((char *) &op, sizeof(Packet));
+	      orig_p = &op;
+	      orig_p->ip6h = p->orig_ip6h;
+	      orig_p->tcph = p->orig_tcph;
+	      orig_p->udph = p->orig_udph;
+	      orig_p->sp = p->orig_sp;
+	      orig_p->dp = p->orig_dp;
+
+	      if(orig_p->ip6h != NULL)
+	      {
+		   fprintf(fp, "\n** ORIGINAL DATAGRAM DUMP:\n");
+		   PrintIP6Header(fp, orig_p);
+
+		   switch(orig_p->ip6h->s_ip6_nxt)
+		   {
+		   case IPPROTO_TCP:
+			/* 
+			 * we can only guarantee the first 8 bytes of the
+			 * tcp header are encapsulated, so lets just print 
+			 * them instead of freaking people out all the time
+			 *   --MFR
+			 */
+			if(orig_p->tcph != NULL)
+			     PrintEmbeddedTCPHeader(fp, orig_p, 
+						    p->dsize - IP6_HEADER_LEN);
+			break;
+		   case IPPROTO_UDP:
+			if(orig_p->udph != NULL)
+			     PrintUDPHeader(fp, orig_p);
+			break;
+		   case IPPROTO_ICMPV6:
+			if(orig_p->icmp6h != NULL)
+			     fprintf(fp, "orig type: %d  code: %d\n", 
+				     orig_p->icmp6h->icmp6_type, orig_p->icmp6h->icmp6_code);
+                            break;
+		   default:
+			fprintf(fp, "Protocol: 0x%X (unknown or "
+				"header truncated)", orig_p->ip6h->s_ip6_nxt);
+			break;
+
+		   }
+
+		   fprintf(fp, "** END OF DUMP");
+	      }
+	      else
+	      {
+		   fprintf(fp, "\nORIGINAL DATAGRAM TRUNCATED");
+	      }
+	 }
+	 break;
+    case ICMP6_PACKET_TOO_BIG:
+    case ICMP6_TIME_EXCEEDED:
+    case ICMP6_PARAM_PROB:
+    default:
+	 ;
+    }
 }
 
 
diff -ur snort-2.0.2/src/log.h snort-2.0.2-ipv6/src/log.h
--- snort-2.0.2/src/log.h	Tue Nov 12 07:17:41 2002
+++ snort-2.0.2-ipv6/src/log.h	Tue Nov 11 11:20:42 2003
@@ -16,7 +16,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: log.h,v 1.22 2002/11/11 22:17:41 andrewbaker Exp $ */
+/* $Id: log.h,v 1.3 2003/11/07 06:26:47 abekatsu Exp $ */
 #ifndef __LOG_H__
 #define __LOG_H__
 
@@ -46,6 +46,7 @@
 
 
 void PrintIPPkt(FILE *, int,Packet*);
+void PrintIP6Pkt(FILE *, int,Packet*);
 void PrintEapolPkt(FILE *, Packet *);
 void PrintEapolKey(FILE *, Packet *);
 void PrintNetData(FILE *, u_char *, const int);
@@ -58,12 +59,14 @@
 void PrintSLLHeader(FILE *, Packet *);
 void PrintArpHeader(FILE *, Packet *);
 void PrintIPHeader(FILE *, Packet *);
+void PrintIP6Header(FILE *, Packet *);
 void PrintEapolHeader(FILE *, Packet *);
 void PrintTCPHeader(FILE *, Packet *);
 void PrintEmbeddedTCPHeader(FILE *, Packet *, int);
 void PrintTcpOptions(FILE *, Packet *);
 void PrintIpOptions(FILE *, Packet *);
 void PrintICMPHeader(FILE *, Packet *);
+void PrintICMP6Header(FILE *, Packet *);
 void PrintUDPHeader(FILE *, Packet *);
 void PrintEAPHeader(FILE *, Packet *);
 void PrintPriorityData(FILE *, int);
diff -ur snort-2.0.2/src/mempool.c snort-2.0.2-ipv6/src/mempool.c
--- snort-2.0.2/src/mempool.c	Fri Mar 14 17:28:50 2003
+++ snort-2.0.2-ipv6/src/mempool.c	Tue Sep 30 13:25:25 2003
@@ -1,4 +1,4 @@
-/* $Id: mempool.c,v 1.5 2003/03/14 08:28:50 chris_reid Exp $ */
+/* $Id: mempool.c,v 1.1.1.1 2003/09/30 04:25:25 abekatsu Exp $ */
 /*
 ** Copyright (C) 2002 Martin Roesch <roesch@sourcefire.com>
 **
@@ -36,7 +36,7 @@
  * memory pool aside from the concerns of alloc/free
  */
 
-/* $Id: mempool.c,v 1.5 2003/03/14 08:28:50 chris_reid Exp $ */
+/* $Id: mempool.c,v 1.1.1.1 2003/09/30 04:25:25 abekatsu Exp $ */
 #include "mempool.h"
 
 /* Function: int mempool_init(MemPool *mempool,
diff -ur snort-2.0.2/src/mempool.h snort-2.0.2-ipv6/src/mempool.h
--- snort-2.0.2/src/mempool.h	Fri Mar 14 17:28:51 2003
+++ snort-2.0.2-ipv6/src/mempool.h	Tue Sep 30 13:25:25 2003
@@ -1,4 +1,4 @@
-/* $Id: mempool.h,v 1.2 2003/03/14 08:28:51 chris_reid Exp $ */
+/* $Id: mempool.h,v 1.1.1.1 2003/09/30 04:25:25 abekatsu Exp $ */
 /*
 ** Copyright (C) 2002 Martin Roesch <roesch@sourcefire.com>
 **
diff -ur snort-2.0.2/src/mpse.c snort-2.0.2-ipv6/src/mpse.c
--- snort-2.0.2/src/mpse.c	Fri Apr  4 05:17:33 2003
+++ snort-2.0.2-ipv6/src/mpse.c	Tue Sep 30 13:25:25 2003
@@ -1,5 +1,5 @@
 /*
-*  $Id: mpse.c,v 1.4 2003/04/03 20:17:33 chrisgreen Exp $
+*  $Id: mpse.c,v 1.1.1.1 2003/09/30 04:25:25 abekatsu Exp $
 *
 *   mpse.c
 *    
diff -ur snort-2.0.2/src/mpse.h snort-2.0.2-ipv6/src/mpse.h
--- snort-2.0.2/src/mpse.h	Fri Apr 11 06:21:51 2003
+++ snort-2.0.2-ipv6/src/mpse.h	Tue Sep 30 13:25:25 2003
@@ -1,5 +1,5 @@
 /*
-** $Id: mpse.h,v 1.3 2003/04/10 21:21:51 chris_reid Exp $
+** $Id: mpse.h,v 1.1.1.1 2003/09/30 04:25:25 abekatsu Exp $
 **
 **  mpse.h       
 **
diff -ur snort-2.0.2/src/mstring.c snort-2.0.2-ipv6/src/mstring.c
--- snort-2.0.2/src/mstring.c	Wed Mar  5 08:00:39 2003
+++ snort-2.0.2-ipv6/src/mstring.c	Tue Sep 30 13:25:25 2003
@@ -1,4 +1,4 @@
-/* $Id: mstring.c,v 1.28 2003/03/04 23:00:39 chrisgreen Exp $ */
+/* $Id: mstring.c,v 1.1.1.1 2003/09/30 04:25:25 abekatsu Exp $ */
 /*
 ** Copyright (C) 1998-2002 Martin Roesch <roesch@sourcefire.com>
 
diff -ur snort-2.0.2/src/mstring.h snort-2.0.2-ipv6/src/mstring.h
--- snort-2.0.2/src/mstring.h	Fri Mar 15 23:48:00 2002
+++ snort-2.0.2-ipv6/src/mstring.h	Tue Sep 30 13:25:25 2003
@@ -16,7 +16,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: mstring.h,v 1.4 2002/03/15 14:48:00 chrisgreen Exp $ */
+/* $Id: mstring.h,v 1.1.1.1 2003/09/30 04:25:25 abekatsu Exp $ */
 
 #ifndef __MSTRING_H__
 #define __MSTRING_H__
diff -ur snort-2.0.2/src/mwm.c snort-2.0.2-ipv6/src/mwm.c
--- snort-2.0.2/src/mwm.c	Tue Apr 22 00:14:18 2003
+++ snort-2.0.2-ipv6/src/mwm.c	Tue Sep 30 13:25:25 2003
@@ -1,5 +1,5 @@
 /*
-**  $Id: mwm.c,v 1.7 2003/04/21 15:14:18 chrisgreen Exp $
+**  $Id: mwm.c,v 1.1.1.1 2003/09/30 04:25:25 abekatsu Exp $
 **
 **  mwm.c   - A Modified Wu-Manber Style Multi-Pattern Matcher
 **
diff -ur snort-2.0.2/src/mwm.h snort-2.0.2-ipv6/src/mwm.h
--- snort-2.0.2/src/mwm.h	Fri Apr 11 06:21:52 2003
+++ snort-2.0.2-ipv6/src/mwm.h	Tue Sep 30 13:25:25 2003
@@ -1,5 +1,5 @@
 /*
-** $Id: mwm.h,v 1.5 2003/04/10 21:21:52 chris_reid Exp $
+** $Id: mwm.h,v 1.1.1.1 2003/09/30 04:25:25 abekatsu Exp $
 **
 **  mwm.h
 **
diff -ur snort-2.0.2/src/output-plugins/spo_alert_fast.c snort-2.0.2-ipv6/src/output-plugins/spo_alert_fast.c
--- snort-2.0.2/src/output-plugins/spo_alert_fast.c	Tue Jul 22 22:42:11 2003
+++ snort-2.0.2-ipv6/src/output-plugins/spo_alert_fast.c	Tue Nov 11 12:02:47 2003
@@ -17,7 +17,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: spo_alert_fast.c,v 1.18 2003/05/19 18:08:04 chrisgreen Exp $ */
+/* $Id: spo_alert_fast.c,v 1.2 2003/11/11 03:02:47 abekatsu Exp $ */
 
 /* spo_alert_fast
  * 
@@ -175,8 +175,6 @@
 
         fprintf(data->file, "{%s} ", protocol_names[p->iph->ip_proto]);
 
-
-
         if(p->frag_flag)
         {
             /* just print the straight IP header */
@@ -204,11 +202,44 @@
                     fputs(inet_ntoa(p->iph->ip_dst), data->file);
             }
         }
-    }               /* end of if (p) */
+    } 
+    else if (p && p->ip6h)
+    {
+	char src[INET6_ADDRSTRLEN], dst[INET6_ADDRSTRLEN];
+
+	(void) inet_ntop(PF_INET6, (void *)&(p->ip6h->ip6_src), src, sizeof(src));
+	(void) inet_ntop(PF_INET6, (void *)&(p->ip6h->ip6_dst), dst, sizeof(src));
+        PrintPriorityData(data->file, 0);
+
+        fprintf(data->file, "{%s} ", protocol_names[p->ip6h->s_ip6_nxt]);
+
+        if(p->frag_flag)
+        {
+            /* just print the straight IP header */
+	    fprintf(data->file, "%s -> %s", src, dst);
+        }
+        else
+        {
+            switch(p->iph->ip_proto)
+            {
+                case IPPROTO_UDP:
+                case IPPROTO_TCP:
+                    /* print the header complete with port information */
+		    fprintf(data->file, "[%s]:%d -> [%s]:%d", src, p->sp, dst, p->dp);
+                    break;
+                case IPPROTO_ICMPV6:
+                default:
+                    /* just print the straight IP header */
+		    fprintf(data->file, "%s -> %s", src, dst);
+            }
+        }
+    }              /* end of if (p) */
     if(p && data->packet_flag)
     {
         if(p->iph)
             PrintIPPkt(data->file, p->iph->ip_proto, p);
+	else if (p->ip6h)
+            PrintIP6Pkt(data->file, p->ip6h->s_ip6_nxt, p);
         else if(p->ah)
             PrintArpHeader(data->file, p);
     }
